package cn.com.infosec.mobile.android.net;

import android.support.annotation.Keep;
import android.support.annotation.NonNull;
import android.text.TextUtils;
import android.util.Base64;
import cn.com.infosec.mobile.android.IMSAction;
import cn.com.infosec.mobile.android.IMSSdk;
import cn.com.infosec.mobile.android.algorithm.SM3;
import cn.com.infosec.mobile.android.algorithm.SM4;
import cn.com.infosec.mobile.android.util.Util;
import cn.com.infosec.mobile.android.xlog.XLog;
import java.io.File;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.UUID;
import java.util.logging.Level;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import org.json.JSONException;
import org.json.JSONObject;

@Keep
public abstract class NetworkInterface {
   private final String[] urlSuffix;

   public NetworkInterface() {
      NetworkInterface var10000 = this;
      super();
      String[] var1;
      String[] var10001 = var1 = new String[3];
      var10001[0] = "/mobile/register";
      var10001[1] = "/mobile/registerNew";
      var10001[2] = "/config/verifyAppId";
      var10000.urlSuffix = var1;
   }

   private Map<String, String> handleHMacEncodeAuth(Map<String, String> params) {
      Map var4;
      if ((var4 = this.handleHMacAuth(params)) != null && !TextUtils.isEmpty(IMSSdk.appIDentifier) && !TextUtils.isEmpty(IMSSdk.appSecretKey)) {
         Iterator params1 = var4.entrySet().iterator();
         String var2 = "";

         while(params1.hasNext()) {
            Map.Entry var3;
            if (!TextUtils.equals("s_random", (CharSequence)(var3 = (Map.Entry)params1.next()).getKey()) && !TextUtils.equals("s_appid", (CharSequence)var3.getKey()) && !TextUtils.equals("s_clienttime", (CharSequence)var3.getKey()) && !TextUtils.equals("s_hash", (CharSequence)var3.getKey())) {
               var2 = var2.concat((String)var3.getKey()).concat("=").concat(URLEncoder.encode((String)var3.getValue())).concat("&");
            }
         }

         if (TextUtils.isEmpty(var2)) {
            return var4;
         } else {
            byte[] params2 = (new SM3()).digest(IMSSdk.appSecretKey.concat((String)var4.get("s_random")).getBytes());
            SM4 var9;
            SM4 var10000 = var9 = new SM4;
            byte[] var10001 = params2;
            byte[] var10002 = params2;
            byte[] var10003 = params2;
            var9.<init>();
            params2 = var2.getBytes();
            byte[] var7 = Arrays.copyOf(var10003, 16);
            byte[] var10 = Arrays.copyOfRange(var10001, 16, var10002.length);
            params2 = var10000.encryptCBC(params2, var7, var10);
            HashMap var8;
            HashMap var11 = var8 = new HashMap;
            var8.<init>();
            var8.put("s_random", var4.get("s_random"));
            var8.put("s_appid", var4.get("s_appid"));
            var8.put("s_clienttime", var4.get("s_clienttime"));
            var8.put("s_hash", var4.get("s_hash"));
            var11.put("encdata", Base64.encodeToString(params2, 2));
            return var11;
         }
      } else {
         return null;
      }
   }

   private Map<String, String> handleOTPAuth(Map<String, String> params) {
      if (params == null) {
         params = new HashMap.<init>(2);
      }

      if (!((Map)params).containsKey("otptype")) {
         ((Map)params).put("otptype", "2");
      }

      if (!((Map)params).containsKey("otpnum")) {
         ((Map)params).put("otpnum", Util.getAuthToken());
      }

      return (Map)params;
   }

   private Map<String, String> handleHMacAuth(Map<String, String> params) {
      Object var57;
      IllegalArgumentException params1;
      label250: {
         IllegalArgumentException var10000;
         label249: {
            Object params2;
            label259: {
               boolean var10001;
               InvalidKeyException var65;
               NoSuchAlgorithmException var66;
               if (params == null) {
                  label245: {
                     label244: {
                        label255: {
                           HashMap var67;
                           try {
                              var67 = new HashMap;
                           } catch (NoSuchAlgorithmException var54) {
                              var66 = var54;
                              var10001 = false;
                              break label244;
                           } catch (InvalidKeyException var55) {
                              var65 = var55;
                              var10001 = false;
                              break label255;
                           } catch (IllegalArgumentException var56) {
                              var10000 = var56;
                              var10001 = false;
                              break label249;
                           }

                           var57 = var67;

                           try {
                              var67.<init>(4);
                              break label245;
                           } catch (NoSuchAlgorithmException var51) {
                              var66 = var51;
                              var10001 = false;
                              break label244;
                           } catch (InvalidKeyException var52) {
                              var65 = var52;
                              var10001 = false;
                           } catch (IllegalArgumentException var53) {
                              var10000 = var53;
                              var10001 = false;
                              break label249;
                           }
                        }

                        InvalidKeyException var61 = var65;
                        var65 = var61;
                        var57 = params;
                        params2 = var65;
                        break label259;
                     }

                     NoSuchAlgorithmException var62 = var66;
                     var66 = var62;
                     var57 = params;
                     params2 = var66;
                     break label259;
                  }
               } else {
                  var57 = params;
               }

               label231: {
                  label230: {
                     label256: {
                        boolean var75;
                        try {
                           var75 = TextUtils.isEmpty(IMSSdk.appIDentifier);
                        } catch (NoSuchAlgorithmException var48) {
                           var66 = var48;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var49) {
                           var65 = var49;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var50) {
                           var10000 = var50;
                           var10001 = false;
                           break label256;
                        }

                        if (var75) {
                           return null;
                        }

                        try {
                           var75 = TextUtils.isEmpty(IMSSdk.appSecretKey);
                        } catch (NoSuchAlgorithmException var45) {
                           var66 = var45;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var46) {
                           var65 = var46;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var47) {
                           var10000 = var47;
                           var10001 = false;
                           break label256;
                        }

                        if (var75) {
                           return null;
                        }

                        Object var10002;
                        String var10003;
                        Object var76;
                        Object var77;
                        try {
                           var77 = var57;
                           var76 = var57;
                           var10002 = var57;
                           var10003 = String.valueOf(System.currentTimeMillis());
                        } catch (NoSuchAlgorithmException var42) {
                           var66 = var42;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var43) {
                           var65 = var43;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var44) {
                           var10000 = var44;
                           var10001 = false;
                           break label256;
                        }

                        String params3 = var10003;

                        try {
                           ((Map)var10002).put("s_random", UUID.randomUUID().toString().replace("-", ""));
                        } catch (NoSuchAlgorithmException var39) {
                           var66 = var39;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var40) {
                           var65 = var40;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var41) {
                           var10000 = var41;
                           var10001 = false;
                           break label256;
                        }

                        String var68 = "s_appid";

                        try {
                           ((Map)var76).put(var68, IMSSdk.appIDentifier);
                        } catch (NoSuchAlgorithmException var36) {
                           var66 = var36;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var37) {
                           var65 = var37;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var38) {
                           var10000 = var38;
                           var10001 = false;
                           break label256;
                        }

                        try {
                           ((Map)var77).put("s_clienttime", params3);
                        } catch (NoSuchAlgorithmException var33) {
                           var66 = var33;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var34) {
                           var65 = var34;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var35) {
                           var10000 = var35;
                           var10001 = false;
                           break label256;
                        }

                        ArrayList var79;
                        try {
                           var79 = new ArrayList;
                        } catch (NoSuchAlgorithmException var30) {
                           var66 = var30;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var31) {
                           var65 = var31;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var32) {
                           var10000 = var32;
                           var10001 = false;
                           break label256;
                        }

                        ArrayList var78 = var79;
                        ArrayList var69 = var79;
                        ArrayList var71 = var79;

                        ArrayList var10004;
                        int var10005;
                        Object var73;
                        try {
                           var10004 = var71;
                           var73 = var57;
                           var10005 = ((Map)var57).size();
                        } catch (NoSuchAlgorithmException var27) {
                           var66 = var27;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var28) {
                           var65 = var28;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var29) {
                           var10000 = var29;
                           var10001 = false;
                           break label256;
                        }

                        var10005 += 3;

                        try {
                           var10004.<init>(var10005);
                           var69.addAll(((Map)var73).keySet());
                        } catch (NoSuchAlgorithmException var24) {
                           var66 = var24;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var25) {
                           var65 = var25;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var26) {
                           var10000 = var26;
                           var10001 = false;
                           break label256;
                        }

                        StringBuilder var80;
                        try {
                           Collections.sort(var78);
                           var80 = new StringBuilder;
                        } catch (NoSuchAlgorithmException var21) {
                           var66 = var21;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var22) {
                           var65 = var22;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var23) {
                           var10000 = var23;
                           var10001 = false;
                           break label256;
                        }

                        StringBuilder params4 = var80;

                        Iterator var81;
                        try {
                           var80.<init>();
                           var81 = var79.iterator();
                        } catch (NoSuchAlgorithmException var18) {
                           var66 = var18;
                           var10001 = false;
                           break label231;
                        } catch (InvalidKeyException var19) {
                           var65 = var19;
                           var10001 = false;
                           break label230;
                        } catch (IllegalArgumentException var20) {
                           var10000 = var20;
                           var10001 = false;
                           break label256;
                        }

                        Iterator var2 = var81;

                        while(true) {
                           try {
                              var75 = var2.hasNext();
                           } catch (NoSuchAlgorithmException var12) {
                              var66 = var12;
                              var10001 = false;
                              break label231;
                           } catch (InvalidKeyException var13) {
                              var65 = var13;
                              var10001 = false;
                              break label230;
                           } catch (IllegalArgumentException var14) {
                              var10000 = var14;
                              var10001 = false;
                              break;
                           }

                           if (!var75) {
                              Mac var70;
                              try {
                                 var77 = var57;
                                 var76 = var57;
                                 var70 = Mac.getInstance("HmacSHA256");
                              } catch (NoSuchAlgorithmException var9) {
                                 var66 = var9;
                                 var10001 = false;
                                 break label231;
                              } catch (InvalidKeyException var10) {
                                 var65 = var10;
                                 var10001 = false;
                                 break label230;
                              } catch (IllegalArgumentException var11) {
                                 var10000 = var11;
                                 var10001 = false;
                                 break;
                              }

                              Mac var74 = var70;

                              byte[] var72;
                              try {
                                 var74.init(new SecretKeySpec(Base64.decode(IMSSdk.appSecretKey, 2), "HmacSHA256"));
                                 var72 = var70.doFinal(params4.toString().getBytes());
                              } catch (NoSuchAlgorithmException var6) {
                                 var66 = var6;
                                 var10001 = false;
                                 break label231;
                              } catch (InvalidKeyException var7) {
                                 var65 = var7;
                                 var10001 = false;
                                 break label230;
                              } catch (IllegalArgumentException var8) {
                                 var10000 = var8;
                                 var10001 = false;
                                 break;
                              }

                              params3 = "s_hash";

                              try {
                                 ((Map)var76).put(params3, Base64.encodeToString(var72, 2));
                                 return (Map)var77;
                              } catch (NoSuchAlgorithmException var3) {
                                 var66 = var3;
                                 var10001 = false;
                                 break label231;
                              } catch (InvalidKeyException var4) {
                                 var65 = var4;
                                 var10001 = false;
                                 break label230;
                              } catch (IllegalArgumentException var5) {
                                 var10000 = var5;
                                 var10001 = false;
                                 break;
                              }
                           }

                           try {
                              params4.append((String)((Map)var57).get((String)var2.next()));
                           } catch (NoSuchAlgorithmException var15) {
                              var66 = var15;
                              var10001 = false;
                              break label231;
                           } catch (InvalidKeyException var16) {
                              var65 = var16;
                              var10001 = false;
                              break label230;
                           } catch (IllegalArgumentException var17) {
                              var10000 = var17;
                              var10001 = false;
                              break;
                           }
                        }
                     }

                     params1 = var10000;
                     break label250;
                  }

                  params2 = var65;
                  break label259;
               }

               params2 = var66;
            }

            IMSSdk.mLogger.log(Level.SEVERE, "handleHMacAuth 失败", var57);
            XLog.d("handleHMacAuth 失败：" + params2);
            return (Map)var57;
         }

         IllegalArgumentException var58 = var10000;
         var10000 = var58;
         var57 = params;
         params1 = var10000;
      }

      XLog.d("handleHMacAuth 失败：" + params1);
      return (Map)var57;
   }

   public static JSONObject handleHMacDecodeAuth(JSONObject jsonObject) {
      String var1;
      if (TextUtils.isEmpty(var1 = jsonObject.optString("data"))) {
         return jsonObject;
      } else {
         byte[] var2 = (new SM3()).digest(IMSSdk.appSecretKey.getBytes());
         SM4 var3;
         SM4 var10000 = var3 = new SM4;
         byte[] var10001 = var2;
         byte[] var10002 = var2;
         var3.<init>();
         byte[] var5 = Base64.decode(var1, 2);
         var2 = Arrays.copyOf(var2, 16);
         byte[] var7 = Arrays.copyOfRange(var10001, 16, var10002.length);
         var5 = var10000.decryptCBC(var5, var2, var7);
         String var6;
         var6 = new String.<init>(var5);

         try {
            return new JSONObject(var6);
         } catch (JSONException var4) {
            XLog.d("handleHMacDecodeAuth 失败：" + var4);
            return jsonObject;
         }
      }
   }

   private boolean notContainUrl(String url) {
      boolean var5 = false;
      String[] var2;
      int var3 = (var2 = this.urlSuffix).length;

      for(int var4 = 0; var4 < var3; ++var4) {
         if (url.endsWith(var2[var4])) {
            var5 = true;
            break;
         }
      }

      return var5 ^ true;
   }

   public abstract String getExactHost();

   public abstract String getSSLTrustCert();

   public void httpGet(String urlSuffix, Map<String, String> params, NetworkCallback<JSONObject> callback) {
      if (IMSSdk.isAppIndex && this.notContainUrl(urlSuffix)) {
         params.put("appIndex", IMSSdk.appIndex);
      }

      XLog.d("开始请求接口 " + urlSuffix);
      if (IMSSdk.enableDebugLog) {
         XLog.d("请求参数 " + params);
      }

      if (this.notContainUrl(urlSuffix)) {
         params = this.doAuthentication(params);
      }

      if (params == null) {
         callback.onFailed("请求数据编码失败");
      } else {
         this.doHTTPGet(urlSuffix, params, callback);
      }
   }

   protected abstract void doHTTPGet(String var1, Map<String, String> var2, NetworkCallback<JSONObject> var3);

   public JSONObject httpGet(String urlSuffix, Map<String, String> params) {
      if (IMSSdk.isAppIndex && this.notContainUrl(urlSuffix)) {
         params.put("appIndex", IMSSdk.appIndex);
      }

      XLog.d("开始请求接口 " + urlSuffix);
      if (IMSSdk.enableDebugLog) {
         XLog.d("请求参数 " + params);
      }

      if (this.notContainUrl(urlSuffix)) {
         params = this.doAuthentication(params);
      }

      return params == null ? null : this.doHTTPGet(urlSuffix, params);
   }

   protected abstract JSONObject doHTTPGet(String var1, Map<String, String> var2);

   public void httpPost(String urlSuffix, Map<String, String> params, NetworkCallback<JSONObject> callback) {
      if (IMSSdk.isAppIndex && this.notContainUrl(urlSuffix)) {
         params.put("appIndex", IMSSdk.appIndex);
      }

      XLog.d("开始请求接口 " + urlSuffix);
      if (IMSSdk.enableDebugLog) {
         XLog.d("请求参数 " + params);
      }

      if (this.notContainUrl(urlSuffix)) {
         params = this.doAuthentication(params);
      }

      if (params == null) {
         callback.onFailed("请求数据编码失败");
      } else {
         this.doHTTPPost(urlSuffix, params, callback);
      }
   }

   protected abstract void doHTTPPost(String var1, Map<String, String> var2, NetworkCallback<JSONObject> var3);

   public JSONObject httpPost(String urlSuffix, Map<String, String> params) {
      if (IMSSdk.isAppIndex && this.notContainUrl(urlSuffix)) {
         params.put("appIndex", IMSSdk.appIndex);
      }

      XLog.d("开始请求接口 " + urlSuffix);
      if (IMSSdk.enableDebugLog) {
         XLog.d("请求参数 " + params);
      }

      if (this.notContainUrl(urlSuffix)) {
         params = this.doAuthentication(params);
      }

      return params == null ? null : this.decodeFilter(this.doHTTPPost(urlSuffix, params));
   }

   protected abstract JSONObject doHTTPPost(String var1, Map<String, String> var2);

   public void download(String url, String destFileName, File destDirectory, NetworkDownloadCallback downloadCallback) {
      this.doDownload(url, destFileName, destDirectory, downloadCallback);
   }

   public boolean download(String url, String destFilePath) {
      return this.doDownload(url, destFilePath);
   }

   public void upload(String url, String key, File srcFile, Map<String, String> params, NetworkUploadCallback uploadCallback) {
      this.doUpload(url, key, srcFile, params, uploadCallback);
   }

   protected abstract void doDownload(String var1, String var2, File var3, NetworkDownloadCallback var4);

   protected abstract boolean doDownload(String var1, String var2);

   protected abstract void doUpload(String var1, String var2, File var3, Map<String, String> var4, NetworkUploadCallback var5);

   public Map<String, String> doAuthentication(Map<String, String> params) {
      int var2 = (new IMSAction(IMSSdk.mContext)).getAPICheckType();
      if (3 == var2) {
         return this.handleHMacEncodeAuth(params);
      } else if (2 == var2) {
         return this.handleHMacAuth(params);
      } else {
         return 1 == var2 ? this.handleOTPAuth(params) : params;
      }
   }

   public JSONObject decodeFilter(JSONObject jsonObject) {
      if (jsonObject != null) {
         return 3 == (new IMSAction(IMSSdk.mContext)).getAPICheckType() ? handleHMacDecodeAuth(jsonObject) : jsonObject;
      } else {
         return null;
      }
   }

   protected String encodeParametersForGet(Map<String, String> params) {
      StringBuilder var3;
      var3 = new StringBuilder.<init>();

      for(Iterator params1 = params.entrySet().iterator(); params1.hasNext(); var3.append('&')) {
         Map.Entry var2;
         var3.append(URLEncoder.encode((String)(var2 = (Map.Entry)params1.next()).getKey()));
         var3.append('=');
         String var5;
         if (!TextUtils.isEmpty(var5 = (String)var2.getValue())) {
            var3.append(URLEncoder.encode(var5));
         }
      }

      return var3.toString();
   }

   protected byte[] encodeParametersForPost(Map<String, String> params, String paramsEncoding) {
      Map var10000 = params;
      StringBuilder var14;
      var14 = new StringBuilder.<init>();

      UnsupportedEncodingException var18;
      label83: {
         boolean var10001;
         Iterator var19;
         try {
            var19 = var10000.entrySet().iterator();
         } catch (UnsupportedEncodingException var13) {
            var18 = var13;
            var10001 = false;
            break label83;
         }

         Iterator params1 = var19;

         while(true) {
            boolean var20;
            try {
               var20 = params1.hasNext();
            } catch (UnsupportedEncodingException var5) {
               var18 = var5;
               var10001 = false;
               break;
            }

            if (!var20) {
               try {
                  return var14.toString().getBytes(paramsEncoding);
               } catch (UnsupportedEncodingException var4) {
                  var18 = var4;
                  var10001 = false;
                  break;
               }
            }

            Map.Entry var10002;
            StringBuilder var21;
            StringBuilder var22;
            try {
               var21 = var14;
               var22 = var14;
               var10002 = (Map.Entry)params1.next();
            } catch (UnsupportedEncodingException var12) {
               var18 = var12;
               var10001 = false;
               break;
            }

            Map.Entry var3 = var10002;

            try {
               var22.append(URLEncoder.encode((String)var10002.getKey(), paramsEncoding));
            } catch (UnsupportedEncodingException var11) {
               var18 = var11;
               var10001 = false;
               break;
            }

            try {
               var21.append('=');
            } catch (UnsupportedEncodingException var10) {
               var18 = var10;
               var10001 = false;
               break;
            }

            String var23;
            try {
               var23 = (String)var3.getValue();
            } catch (UnsupportedEncodingException var9) {
               var18 = var9;
               var10001 = false;
               break;
            }

            String var17 = var23;

            try {
               var20 = TextUtils.isEmpty(var23);
            } catch (UnsupportedEncodingException var8) {
               var18 = var8;
               var10001 = false;
               break;
            }

            if (!var20) {
               try {
                  var14.append(URLEncoder.encode(var17, paramsEncoding));
               } catch (UnsupportedEncodingException var7) {
                  var18 = var7;
                  var10001 = false;
                  break;
               }
            }

            try {
               var14.append('&');
            } catch (UnsupportedEncodingException var6) {
               var18 = var6;
               var10001 = false;
               break;
            }
         }
      }

      UnsupportedEncodingException var15 = var18;
      throw new RuntimeException("不支持的编码格式: " + paramsEncoding, var15);
   }

   @Keep
   public abstract static class NetworkUploadCallback extends NetworkCallback<String> {
      public abstract void onStart();

      public abstract void onProgress(int var1, int var2);
   }

   @Keep
   public abstract static class NetworkDownloadCallback extends NetworkCallback<File> {
      public abstract void onStart();

      public abstract void onProgress(int var1, int var2);
   }

   @Keep
   public abstract static class NetworkCallback<T> {
      public abstract void onSucceed(@NonNull T var1);

      public JSONObject decodeFilter(JSONObject jsonObject) {
         return 3 == (new IMSAction(IMSSdk.mContext)).getAPICheckType() ? NetworkInterface.handleHMacDecodeAuth(jsonObject) : jsonObject;
      }

      public abstract void onFailed(@NonNull String var1);
   }
}
